import React, { useState, useEffect } from 'react';
import { ProDescriptions } from '@ant-design/pro-components';
import { Divider, Button, Tooltip } from 'antd';
import { doFetch } from '@/utils/doFetch';
import { MoreOutlined } from '@ant-design/icons';
import { useRequest } from 'ahooks';
import DesItem from './DesItem';
export default (props) => {
  const { type, detailpath, params, baseRow, basecolumns, title, titleno } = props;
  const [hidden, sethidden] = useState(false);

  const request = useRequest(async () => {
    console.log(detailpath, params);
    let res = await doFetch({ url: detailpath, params });
    // const res = {
    //   code: '0000',
    //   msg: '',
    //   data: {
    //     dataList: [
    //       {
    //         id: '2022112931558310704',
    //         createTime: '2022-11-29 16:00:20',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:00:20',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 1,
    //         operationTypeName: '接单',
    //         sort: 0,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: '2022112227061106731',
    //         repairName: 'HDKF1',
    //         repairTime: '2022-11-29 16:00:20',
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: null,
    //         trackerName: null,
    //         trackerTime: null,
    //         planTrackTime: null,
    //         actualTrackTime: null,
    //         trackResult: null,
    //         trackResults: null,
    //         isFinishTrack: null,
    //         finishTrack: null,
    //         trackCycle: null,
    //         trackContents: null,
    //         trackProcessList: null,
    //       },
    //       {
    //         id: '2022112930928687096',
    //         createTime: '2022-11-29 16:43:41',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:43:41',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 4,
    //         operationTypeName: '追踪',
    //         sort: 1,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: null,
    //         repairName: null,
    //         repairTime: null,
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: null,
    //         trackerName: null,
    //         trackerTime: null,
    //         planTrackTime: null,
    //         actualTrackTime: null,
    //         trackResult: null,
    //         trackResults: null,
    //         isFinishTrack: null,
    //         finishTrack: null,
    //         trackCycle: null,
    //         trackContents: null,
    //         trackProcessList: null,
    //       },
    //       {
    //         id: '2022112932446783387',
    //         createTime: '2022-11-29 16:55:41',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:55:41',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 4,
    //         operationTypeName: '追踪',
    //         sort: 2,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: null,
    //         repairName: null,
    //         repairTime: null,
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: '2022112227061106731',
    //         trackerName: 'HDKF1',
    //         trackerTime: '2022-12-08 11:27:06',
    //         planTrackTime: '2022-11-29',
    //         actualTrackTime: null,
    //         trackResult: 1,
    //         trackResults: '通过',
    //         isFinishTrack: 1,
    //         finishTrack: '是',
    //         trackCycle: 7,
    //         trackContents: '追踪内容',
    //         trackProcessList: [
    //           {
    //             id: '2022113026622115346',
    //             createTime: '2022-11-30 09:36:31',
    //             createUserId: '2022112227061106731',
    //             createUserName: 'HDKF1',
    //             updateTime: '2022-11-30 09:36:31',
    //             updateUserId: '2022112227061106731',
    //             updateUserName: 'HDKF1',
    //             isDelete: 0,
    //             pageIndex: 0,
    //             pageSize: 10,
    //             companyId: '2022110829866490982',
    //             traceinfoId: '2022112930737666134',
    //             reviewerId: null,
    //             reviewerName: null,
    //             reviewerTime: null,
    //             reviewerResult: 1,
    //             reviewerResultName: null,
    //             remark: '备注',
    //           },
    //         ],
    //       },
    //       {
    //         id: '2022112932446783387',
    //         createTime: '2022-11-29 16:55:41',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:55:41',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 4,
    //         operationTypeName: '追踪',
    //         sort: 2,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: null,
    //         repairName: null,
    //         repairTime: null,
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: '2022112227061106731',
    //         trackerName: 'HDKF1',
    //         trackerTime: '2022-12-08 11:27:06',
    //         planTrackTime: '2022-11-29',
    //         actualTrackTime: null,
    //         trackResult: 1,
    //         trackResults: '通过',
    //         isFinishTrack: 1,
    //         finishTrack: '是',
    //         trackCycle: 7,
    //         trackContents: '追踪内容',
    //         trackProcessList: [
    //           {
    //             id: '2022113026622115346',
    //             createTime: '2022-11-30 09:36:31',
    //             createUserId: '2022112227061106731',
    //             createUserName: 'HDKF1',
    //             updateTime: '2022-11-30 09:36:31',
    //             updateUserId: '2022112227061106731',
    //             updateUserName: 'HDKF1',
    //             isDelete: 0,
    //             pageIndex: 0,
    //             pageSize: 10,
    //             companyId: '2022110829866490982',
    //             traceinfoId: '2022112930737666134',
    //             reviewerId: null,
    //             reviewerName: null,
    //             reviewerTime: null,
    //             reviewerResult: 1,
    //             reviewerResultName: null,
    //             remark: '备注',
    //           },
    //         ],
    //       },
    //       {
    //         id: '2022112932446783387',
    //         createTime: '2022-11-29 16:55:41',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:55:41',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 4,
    //         operationTypeName: '追踪',
    //         sort: 2,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: null,
    //         repairName: null,
    //         repairTime: null,
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: '2022112227061106731',
    //         trackerName: 'HDKF1',
    //         trackerTime: '2022-12-08 11:27:06',
    //         planTrackTime: '2022-11-29',
    //         actualTrackTime: null,
    //         trackResult: 1,
    //         trackResults: '通过',
    //         isFinishTrack: 1,
    //         finishTrack: '是',
    //         trackCycle: 7,
    //         trackContents: '追踪内容',
    //         trackProcessList: [
    //           {
    //             id: '2022113026622115346',
    //             createTime: '2022-11-30 09:36:31',
    //             createUserId: '2022112227061106731',
    //             createUserName: 'HDKF1',
    //             updateTime: '2022-11-30 09:36:31',
    //             updateUserId: '2022112227061106731',
    //             updateUserName: 'HDKF1',
    //             isDelete: 0,
    //             pageIndex: 0,
    //             pageSize: 10,
    //             companyId: '2022110829866490982',
    //             traceinfoId: '2022112930737666134',
    //             reviewerId: null,
    //             reviewerName: null,
    //             reviewerTime: null,
    //             reviewerResult: 1,
    //             reviewerResultName: null,
    //             remark: '备注',
    //           },
    //         ],
    //       },
    //       {
    //         id: '2022112932446783387',
    //         createTime: '2022-11-29 16:55:41',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:55:41',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 4,
    //         operationTypeName: '追踪',
    //         sort: 2,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: null,
    //         repairName: null,
    //         repairTime: null,
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: '2022112227061106731',
    //         trackerName: 'HDKF1',
    //         trackerTime: '2022-12-08 11:27:06',
    //         planTrackTime: '2022-11-29',
    //         actualTrackTime: null,
    //         trackResult: 1,
    //         trackResults: '通过',
    //         isFinishTrack: 1,
    //         finishTrack: '是',
    //         trackCycle: 7,
    //         trackContents: '追踪内容',
    //         trackProcessList: [
    //           {
    //             id: '2022113026622115346',
    //             createTime: '2022-11-30 09:36:31',
    //             createUserId: '2022112227061106731',
    //             createUserName: 'HDKF1',
    //             updateTime: '2022-11-30 09:36:31',
    //             updateUserId: '2022112227061106731',
    //             updateUserName: 'HDKF1',
    //             isDelete: 0,
    //             pageIndex: 0,
    //             pageSize: 10,
    //             companyId: '2022110829866490982',
    //             traceinfoId: '2022112930737666134',
    //             reviewerId: null,
    //             reviewerName: null,
    //             reviewerTime: null,
    //             reviewerResult: 1,
    //             reviewerResultName: null,
    //             remark: '备注',
    //           },
    //         ],
    //       },
    //       {
    //         id: '2022112932446783387',
    //         createTime: '2022-11-29 16:55:41',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:55:41',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 4,
    //         operationTypeName: '追踪',
    //         sort: 2,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: null,
    //         repairName: null,
    //         repairTime: null,
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: '2022112227061106731',
    //         trackerName: 'HDKF1',
    //         trackerTime: '2022-12-08 11:27:06',
    //         planTrackTime: '2022-11-29',
    //         actualTrackTime: null,
    //         trackResult: 1,
    //         trackResults: '通过',
    //         isFinishTrack: 1,
    //         finishTrack: '是',
    //         trackCycle: 7,
    //         trackContents: '追踪内容',
    //         trackProcessList: [
    //           {
    //             id: '2022113026622115346',
    //             createTime: '2022-11-30 09:36:31',
    //             createUserId: '2022112227061106731',
    //             createUserName: 'HDKF1',
    //             updateTime: '2022-11-30 09:36:31',
    //             updateUserId: '2022112227061106731',
    //             updateUserName: 'HDKF1',
    //             isDelete: 0,
    //             pageIndex: 0,
    //             pageSize: 10,
    //             companyId: '2022110829866490982',
    //             traceinfoId: '2022112930737666134',
    //             reviewerId: null,
    //             reviewerName: null,
    //             reviewerTime: null,
    //             reviewerResult: 1,
    //             reviewerResultName: null,
    //             remark: '备注',
    //           },
    //         ],
    //       },
    //       {
    //         id: '2022112932446783387',
    //         createTime: '2022-11-29 16:55:41',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:55:41',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 4,
    //         operationTypeName: '追踪',
    //         sort: 2,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: null,
    //         repairName: null,
    //         repairTime: null,
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: '2022112227061106731',
    //         trackerName: 'HDKF1',
    //         trackerTime: '2022-12-08 11:27:06',
    //         planTrackTime: '2022-11-29',
    //         actualTrackTime: null,
    //         trackResult: 1,
    //         trackResults: '通过',
    //         isFinishTrack: 1,
    //         finishTrack: '是',
    //         trackCycle: 7,
    //         trackContents: '追踪内容',
    //         trackProcessList: [
    //           {
    //             id: '2022113026622115346',
    //             createTime: '2022-11-30 09:36:31',
    //             createUserId: '2022112227061106731',
    //             createUserName: 'HDKF1',
    //             updateTime: '2022-11-30 09:36:31',
    //             updateUserId: '2022112227061106731',
    //             updateUserName: 'HDKF1',
    //             isDelete: 0,
    //             pageIndex: 0,
    //             pageSize: 10,
    //             companyId: '2022110829866490982',
    //             traceinfoId: '2022112930737666134',
    //             reviewerId: null,
    //             reviewerName: null,
    //             reviewerTime: null,
    //             reviewerResult: 1,
    //             reviewerResultName: null,
    //             remark: '备注',
    //           },
    //         ],
    //       },
    //       {
    //         id: '2022112932446783387',
    //         createTime: '2022-11-29 16:55:41',
    //         createUserId: '2022112227061106731',
    //         createUserName: 'HDKF1',
    //         updateTime: '2022-11-29 16:55:41',
    //         updateUserId: '2022112227061106731',
    //         updateUserName: 'HDKF1',
    //         isDelete: 0,
    //         pageIndex: 0,
    //         pageSize: 10,
    //         companyId: '2022110829866490982',
    //         trackOrderId: '2022112925456100066',
    //         operationType: 4,
    //         operationTypeName: '追踪',
    //         sort: 2,
    //         workOrderId: null,
    //         umTrackOrder: null,
    //         trackOrderReceiving: null,
    //         trackTraceinfo: null,
    //         assistUserNames: null,
    //         repairId: null,
    //         repairName: null,
    //         repairTime: null,
    //         dispatcherId: null,
    //         dispatcherName: null,
    //         dispatcherTime: null,
    //         trackerId: '2022112227061106731',
    //         trackerName: 'HDKF1',
    //         trackerTime: '2022-12-08 11:27:06',
    //         planTrackTime: '2022-11-29',
    //         actualTrackTime: null,
    //         trackResult: 1,
    //         trackResults: '通过',
    //         isFinishTrack: 1,
    //         finishTrack: '是',
    //         trackCycle: 7,
    //         trackContents: '追踪内容',
    //         trackProcessList: [
    //           {
    //             id: '2022113026622115346',
    //             createTime: '2022-11-30 09:36:31',
    //             createUserId: '2022112227061106731',
    //             createUserName: 'HDKF1',
    //             updateTime: '2022-11-30 09:36:31',
    //             updateUserId: '2022112227061106731',
    //             updateUserName: 'HDKF1',
    //             isDelete: 0,
    //             pageIndex: 0,
    //             pageSize: 10,
    //             companyId: '2022110829866490982',
    //             traceinfoId: '2022112930737666134',
    //             reviewerId: null,
    //             reviewerName: null,
    //             reviewerTime: null,
    //             reviewerResult: 1,
    //             reviewerResultName: null,
    //             remark: '备注',
    //           },
    //         ],
    //       },
    //     ],
    //   },
    // };
    if (res?.data?.dataList?.length > 4) {
      sethidden(true);
    }
    return res?.data || {};
  });

  // 维修工单
  const Wxgd = () => {
    return (
      <>
        <DesItem
          dataSource={request?.data?.dataList[0]}
          title="报修信息"
          hidden={true}
          index="0"
          // navhidden={false}
        />
        {request?.data?.dataList?.splice(1).map((it, index) => {
          return (
            <>
              <DesItem
                type="wxgd"
                dataSource={it}
                index={index + 2}
                hidden={true}
                navhidden={false}
              />
            </>
          );
        })}
      </>
    );
  };
  // 追踪工单
  const Zzgd = () => {
    return hidden ? (
      <>
        <DesItem
          dataSource={request?.data?.dataList[0]}
          title="基本信息"
          hidden={true}
          index="0"
          // navhidden={false}
        />
        <DesItem
          type="zzgd"
          dataSource={request?.data?.dataList[1]}
          index={'2'}
          hidden={true}
          navhidden={false}
        />
        <div className="fault-detail" style={{ paddingTop: 30, paddingBottom: 30 }}>
          <Tooltip title="点击展开">
            <Button
              type="primary"
              shape="circle"
              icon={<MoreOutlined />}
              onClick={() => {
                sethidden(false);
              }}
            />
          </Tooltip>
        </div>
        <DesItem
          type="zzgd"
          dataSource={request?.data?.dataList[request?.data?.dataList?.length - 2]}
          index={request?.data?.dataList?.length - 1}
          hidden={true}
          navhidden={false}
        />
        <DesItem
          type="zzgd"
          dataSource={request?.data?.dataList[request?.data?.dataList?.length - 1]}
          index={request?.data?.dataList?.length}
          hidden={true}
          navhidden={false}
        />
        {/* {request?.data?.dataList?.splice(1).map((it, index) => {
    return (
      <>
        <DesItem
          type="zzgd"
          dataSource={it}
          index={index + 2}
          hidden={true}
          navhidden={false}
        />
      </>
    );
  })} */}
      </>
    ) : (
      <>
        <DesItem
          dataSource={request?.data?.dataList[0]}
          title="基本信息"
          hidden={true}
          index="0"
          // navhidden={false}
        />
        {request?.data?.dataList?.splice(1).map((it, index) => {
          return (
            <>
              <DesItem
                type="zzgd"
                dataSource={it}
                index={index + 2}
                hidden={true}
                navhidden={false}
              />
            </>
          );
        })}
      </>
    );
  };
  const selectType = {
    gzbx: (
      <DesItem
        type="gzbx"
        index="0"
        dataSource={request?.data?.data}
        title="基本信息"
        hidden={true}
        navhidden={true}
      />
    ),
    wxgd: <Wxgd />,
    zzgd: <Zzgd />,
  };
  return (
    <>
      <div>
        <h2 style={{ fontWeight: 700 }}>
          {title}：{titleno}
        </h2>
      </div>
      <ProDescriptions columns={basecolumns} dataSource={baseRow} />
      <Divider />
      {selectType[type]}
    </>
  );
};
